#start
scoreboard players set @a[tag=start] fail 0
team join player @a[tag=start]
title @a[tag=start] title {"text":" "}
title @a[tag=start] subtitle {"text":"Good luck!","color":"green"}
gamemode adventure @a[tag=start]
tp @a[tag=start] @e[type=armor_stand,sort=nearest,limit=1,tag=checkpoint]
tag @a remove start

#effects
effect give @a saturation 1000000 255 true
effect give @a resistance 1000000 255 true
effect give @a weakness 1000000 255 true

#checkpoint
execute at @a if block ~ ~-0.25 ~ minecraft:quartz_slab[type=double] run tp @e[type=armor_stand,tag=checkpoint,sort=nearest,limit=1] @p
execute at @a if block ~ ~-0.1 ~ minecraft:smooth_quartz run scoreboard players add @p fail 1
execute at @a if block ~ ~-0.1 ~ minecraft:smooth_quartz run tp @p @e[type=armor_stand,tag=checkpoint,sort=nearest,limit=1]
spawnpoint @a -198 62 -131

#joins
scoreboard players add @a[tag=!new] spawnTp 1
tp @a[scores={spawnTp=1..}] -198 62 -131
scoreboard players reset @a[scores={spawnTp=1..}] spawnTp
team join player @a[tag=!new]
tellraw @a[tag=!new] ["",{"text":"Welcome, "},{"selector":"@a[tag=!new]"}]
team join player @a[scores={join=1..}]
tellraw @a[scores={join=1..}] ["",{"text":"Welcome back, "},{"selector":"@a[scores={join=1..}]"}]
effect clear @a[scores={join=1..}]
tag @a add new
scoreboard players reset @a join

#no fall damage
tag @a[nbt={FallDistance:0.0f}] add NotFalling
scoreboard players reset @a[tag=NotFalling] Falling
effect clear @a[tag=NotFalling] minecraft:jump_boost
effect give @a[scores={Falling=9..}] minecraft:jump_boost 1 255 true
tag @a remove NotFalling

#ding
execute at @a if block ~ ~-0.25 ~ minecraft:quartz_slab[type=double] run execute as @e[type=armor_stand,sort=nearest,limit=1,tag=ding,distance=..1] run playsound minecraft:entity.arrow.hit_player master @p
execute at @a if block ~ ~-0.25 ~ minecraft:quartz_slab[type=double] run execute as @e[type=armor_stand,sort=nearest,tag=ding,distance=..1] run kill @e[type=armor_stand,sort=nearest,limit=1,tag=ding,distance=..1]

#level block particles
execute at @e[type=armor_stand,tag=block] run particle dragon_breath ~ ~0.5 ~ 0.1 0.1 0.1 0 1

execute at @e[type=armor_stand,tag=corners] run particle dragon_breath ~0.45 ~ ~0.45 0.01 0.01 0.01 0 1
execute at @e[type=armor_stand,tag=corners] run particle dragon_breath ~-0.45 ~ ~-0.45 0.01 0.01 0.01 0 1
execute at @e[type=armor_stand,tag=corners] run particle dragon_breath ~-0.45 ~ ~0.45 0.01 0.01 0.01 0 1
execute at @e[type=armor_stand,tag=corners] run particle dragon_breath ~0.45 ~ ~-0.45 0.01 0.01 0.01 0 1
execute at @e[type=armor_stand,tag=corners] run particle dragon_breath ~0.45 ~1 ~0.45 0.01 0.01 0.01 0 1
execute at @e[type=armor_stand,tag=corners] run particle dragon_breath ~-0.45 ~1 ~-0.45 0.01 0.01 0.01 0 1
execute at @e[type=armor_stand,tag=corners] run particle dragon_breath ~-0.45 ~1 ~0.45 0.01 0.01 0.01 0 1
execute at @e[type=armor_stand,tag=corners] run particle dragon_breath ~0.45 ~1 ~-0.45 0.01 0.01 0.01 0 1

#level portal tp
execute at @e[type=armor_stand,tag=portal1] run tp @a[distance=..1] @e[type=armor_stand,tag=portal2,sort=nearest,limit=1]

#level slow falling
execute at @a if block ~ ~0.8 ~ minecraft:heavy_weighted_pressure_plate run effect give @p slow_falling 2

#end
execute at @e[type=armor_stand,tag=gate] run execute at @a[distance=..5] if block ~ ~ ~ minecraft:end_gateway run tag @p add done
tellraw @a[tag=done] ["",{"text":"Congratulations! ","color":"gold"},{"text":"You beat all ","color":"green"},{"text":"100","underlined":true,"color":"green"},{"text":" levels with ","color":"green"},{"score":{"name":"@a[tag=done]","objective":"fail"},"color":"dark_green"},{"text":" fails!","color":"green"}]
tellraw @a[tag=done] ["",{"text":"Thanks for playing!","color":"yellow"}]
tellraw @a[tag=done] {"text":" "}
tellraw @a[tag=done] ["",{"text":" Map made by: ","color":"yellow"},{"text":"PvPqnda","color":"red","bold":"true"}]
gamemode spectator @a[tag=done]
title @a[tag=done] title {"text":" "}
title @a[tag=done] subtitle {"text":"Thanks for playing!","color":"gold","bold":"true"}
team join done @a[tag=done]
execute at @e[type=armor_stand,sort=nearest,limit=1,tag=finish] run tp @a[tag=done] ~ ~50 ~
execute at @a[tag=done] run playsound minecraft:ui.toast.challenge_complete master @p
tag @a[tag=done] add fw
tag @a remove done

#fireworks
scoreboard players add @a[tag=fw] fw 1
execute as @a[scores={fw=20}] run summon firework_rocket -181 58 -100 {LifeTime:0,FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Trail:1,Colors:[I;4312372]}],Flight:1}}}}
execute as @a[scores={fw=40}] run summon firework_rocket -201 52 -93 {LifeTime:0,FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Trail:1,Colors:[I;4312372]}],Flight:1}}}}
execute as @a[scores={fw=60}] run summon firework_rocket -200 47 -167 {LifeTime:0,FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Trail:1,Colors:[I;4312372]}],Flight:1}}}}
execute as @a[scores={fw=80}] run summon firework_rocket -171 52 -133 {LifeTime:0,FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Trail:1,Colors:[I;4312372]}],Flight:1}}}}
execute as @a[scores={fw=100}] run summon firework_rocket -225 50 -139 {LifeTime:0,FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Trail:1,Colors:[I;4312372]}],Flight:1}}}}
execute as @a[scores={fw=120}] run summon firework_rocket -182 57 -158 {LifeTime:0,FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Trail:1,Colors:[I;4312372]}],Flight:1}}}}
execute as @a[scores={fw=140}] run summon firework_rocket -179 47 -114 {LifeTime:0,FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Trail:1,Colors:[I;4312372]}],Flight:1}}}}
execute as @a[scores={fw=160}] run summon firework_rocket -218 47 -157 {LifeTime:0,FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Trail:1,Colors:[I;4312372]}],Flight:1}}}}
execute as @a[scores={fw=180}] run summon firework_rocket -216 40 -116 {LifeTime:0,FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Trail:1,Colors:[I;4312372]}],Flight:1}}}}
execute as @a[scores={fw=200}] run summon firework_rocket -175 43 -158 {LifeTime:0,FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:1,Trail:1,Colors:[I;4312372]}],Flight:1}}}}
execute as @a[scores={fw=201..}] run tag @p remove fw
execute as @a[scores={fw=201..}] run scoreboard players reset @p fw